Index: pykota/trunk/pykota/version.py
===================================================================
--- pykota/trunk/pykota/version.py (revision 1522)
+++ pykota/trunk/pykota/version.py (revision 1526)
@@ -22,5 +22,5 @@
 #
 
-__version__ = "1.19alpha18_unofficial"
+__version__ = "1.19alpha19_unofficial"
 
 __doc__ = """PyKota : a complete Printing Quota Solution for CUPS and LPRng."""
Index: pykota/trunk/bin/warnpykota
===================================================================
--- pykota/trunk/bin/warnpykota (revision 1517)
+++ pykota/trunk/bin/warnpykota (revision 1526)
@@ -24,4 +24,7 @@
 #
 # $Log$
+# Revision 1.28  2004/06/07 18:43:41  jalet
+# Fixed over-verbose exits when displaying help or version number
+#
 # Revision 1.27  2004/06/03 21:50:34  jalet
 # Improved error logging.
@@ -252,4 +255,6 @@
         else :
             retcode = sender.main(args, options)
+    except SystemExit :        
+        pass
     except :
         try :
Index: pykota/trunk/bin/edpykota
===================================================================
--- pykota/trunk/bin/edpykota (revision 1517)
+++ pykota/trunk/bin/edpykota (revision 1526)
@@ -24,4 +24,7 @@
 #
 # $Log$
+# Revision 1.74  2004/06/07 18:43:40  jalet
+# Fixed over-verbose exits when displaying help or version number
+#
 # Revision 1.73  2004/06/03 21:50:34  jalet
 # Improved error logging.
@@ -695,4 +698,6 @@
         else :
             retcode = editor.main(args, options)
+    except SystemExit :        
+        pass
     except :
         try :
Index: pykota/trunk/bin/pkprinters
===================================================================
--- pykota/trunk/bin/pkprinters (revision 1517)
+++ pykota/trunk/bin/pkprinters (revision 1526)
@@ -24,4 +24,7 @@
 #
 # $Log$
+# Revision 1.10  2004/06/07 18:43:40  jalet
+# Fixed over-verbose exits when displaying help or version number
+#
 # Revision 1.9  2004/06/03 21:50:34  jalet
 # Improved error logging.
@@ -260,4 +263,6 @@
         else :
             retcode = manager.main(args, options)
+    except SystemExit :        
+        pass
     except :
         try :
Index: pykota/trunk/bin/pykotme
===================================================================
--- pykota/trunk/bin/pykotme (revision 1517)
+++ pykota/trunk/bin/pykotme (revision 1526)
@@ -24,4 +24,7 @@
 #
 # $Log$
+# Revision 1.11  2004/06/07 18:43:40  jalet
+# Fixed over-verbose exits when displaying help or version number
+#
 # Revision 1.10  2004/06/03 21:50:34  jalet
 # Improved error logging.
@@ -191,4 +194,6 @@
         else :
             retcode = sender.main(args, options)
+    except SystemExit :        
+        pass
     except :
         try :
Index: pykota/trunk/bin/pkhint
===================================================================
--- pykota/trunk/bin/pkhint (revision 1517)
+++ pykota/trunk/bin/pkhint (revision 1526)
@@ -24,4 +24,7 @@
 #
 # $Log$
+# Revision 1.10  2004/06/07 18:43:40  jalet
+# Fixed over-verbose exits when displaying help or version number
+#
 # Revision 1.9  2004/06/03 21:50:34  jalet
 # Improved error logging.
@@ -271,4 +274,6 @@
                 args = [ "*" ]
             retcode = manager.main(args, options)
+    except SystemExit :        
+        pass
     except :
         try :
Index: pykota/trunk/bin/repykota
===================================================================
--- pykota/trunk/bin/repykota (revision 1517)
+++ pykota/trunk/bin/repykota (revision 1526)
@@ -24,4 +24,7 @@
 #
 # $Log$
+# Revision 1.48  2004/06/07 18:43:41  jalet
+# Fixed over-verbose exits when displaying help or version number
+#
 # Revision 1.47  2004/06/03 21:50:34  jalet
 # Improved error logging.
@@ -284,4 +287,5 @@
                     
 if __name__ == "__main__" : 
+    retcode = 0
     try :
         defaults = { \
@@ -312,4 +316,6 @@
         else :
             retcode = reportTool.main(args, options)
+    except SystemExit :        
+        pass
     except :
         try :
Index: pykota/trunk/NEWS
===================================================================
--- pykota/trunk/NEWS (revision 1524)
+++ pykota/trunk/NEWS (revision 1526)
@@ -22,4 +22,8 @@
 PyKota NEWS :
 
+    - 1.19alpha19 :
+    
+        - Fixed over-verbose exits when displaying help
+          or version.
 
     - 1.19alpha18 :