Index: /pykota/trunk/README
===================================================================
--- /pykota/trunk/README (revision 1575)
+++ /pykota/trunk/README (revision 1578)
@@ -71,5 +71,5 @@
           This is completely configurable.
           
-        - Supports DSC compliant PostScript, PDF, PCL5 and 
+        - Supports DSC compliant PostScript, PDF, PCL5, and
           PCLXL (aka PCL6) printers natively for software 
           accounting methods. More formats to come.
@@ -239,5 +239,5 @@
   on Psyco's website.
   
-  Installing Psyco is not mandatory, but it woud speedup PCL5 parsing
+  Installing Psyco is not mandatory, but it will speedup PCL5 parsing
   by almost 3 times. PostScript and PDF parsing can also benefit,
   but in an almost unnoticeable manner since this part of the code
@@ -245,5 +245,5 @@
   and if you install Psyco you will never regret it !
   Same remark applies for PCL6 (aka PCLXL) but performance improvement
-  is yet to be tested (it is high anyway).
+  is yet to be fully tested (it is very high anyway).
   
   You may also benefit from having the following tools installed to
Index: /pykota/trunk/FAQ
===================================================================
--- /pykota/trunk/FAQ (revision 1538)
+++ /pykota/trunk/FAQ (revision 1578)
@@ -59,9 +59,9 @@
   
     In PyKota, the term 'dumb printer' defines a printer which doesn't 
-    understand PostScript or PCL5 AND doesn't have an internal page 
-    counter, AND for which you don't know how to compute a job's size 
-    in number of pages by analyzing its content. Any printer which 
-    is not a 'dumb printer' according to the above definition is 
-    supported by PyKota.
+    understand PostScript, PCL5, PCLXL (aka PCL6) or PDF AND doesn't 
+    have an internal page counter, AND for which you don't know how to 
+    compute a job's size in number of pages by analyzing its content. 
+    Any printer which is not a 'dumb printer' according to the above 
+    definition is supported by PyKota.
 
   * How can I make PyKota work with my non-postscript printer under 
@@ -78,8 +78,7 @@
     Page Description Language.
     
-    PyKota natively understands PostScript and PCL5,
-    but PCL6 support is in the works, and more PDLs
-    will be added in the future. However you can always
-    plug your own PDL analyzer in PyKota.
+    PyKota natively understands PostScript, PCL5, PCLXL (aka PCL6)
+    and PDF. More PDLs will be added in the future. However you can 
+    always plug your own PDL analyzer in PyKota.
           
   * I've got a great number of users. How can I automatically
Index: /pykota/trunk/bin/pkhint
===================================================================
--- /pykota/trunk/bin/pkhint (revision 1546)
+++ /pykota/trunk/bin/pkhint (revision 1578)
@@ -24,4 +24,7 @@
 #
 # $Log$
+# Revision 1.12  2004/06/29 07:53:11  jalet
+# Improved pkhint
+#
 # Revision 1.11  2004/06/18 13:34:48  jalet
 # Now all tracebacks include PyKota's version number
@@ -122,5 +125,5 @@
                 '/bin/nc -w 2 %(printer)s %(port)s </usr/share/pykota/pagecount.pjl 2>/dev/null | /usr/bin/tail -2', \
               ]
-
+              
 class PKHint(PyKotaTool) :
     """A class to autodetect the best accounting method for printers."""
@@ -236,10 +239,14 @@
                             accounter = 'hardware(' + netpjlcommand + ')'
                             configuration.append((printer, accounter))
-                elif devicetype == "direct" : 
-                    sys.stderr.write("Can't currently handle device %s for printer %s\n" % (device, printer))
-                elif devicetype == "serial" : 
-                    sys.stderr.write("Can't currently handle device %s for printer %s\n" % (device, printer))
+                        else :    
+                            configuration.append((printer, "software(/usr/bin/pkpgcounter)"))
+                # elif devicetype == "direct" : 
+                #    sys.stderr.write("Can't currently handle device %s for printer %s\n" % (device, printer))
+                #elif devicetype == "serial" : 
+                #    sys.stderr.write("Can't currently handle device %s for printer %s\n" % (device, printer))
+                #else :
+                #    sys.stderr.write("Can't currently handle device %s for printer %s\n" % (device, printer))
                 else :
-                    sys.stderr.write("Can't currently handle device %s for printer %s\n" % (device, printer))
+                    configuration.append((printer, "software(/usr/bin/pkpgcounter)"))
                     
         if not configuration :            
@@ -247,4 +254,7 @@
         else :
             print "\nPut the following lines into your /etc/pykota/pykota.conf file :\n"
+            print "# BEWARE : if software accounting is suggested, this doesn't mean"
+            print "# that hardware accounting wouldn't work, this only means that PyKota"
+            print "# wasn't able to autodetect which hardware accounting method to use."
             for (printer, accounter) in configuration :
                 print "[%s]" % printer
@@ -254,5 +264,4 @@
 if __name__ == "__main__" : 
     sys.stderr.write("BEWARE : This tool doesn't support LPRng's printcap files yet.\n")
-    sys.stderr.write("This tool is currently highly experimental, so don't rely on it.\n")
     retcode = 0
     try :
Index: /pykota/trunk/man/edpykota.1
===================================================================
--- /pykota/trunk/man/edpykota.1 (revision 1540)
+++ /pykota/trunk/man/edpykota.1 (revision 1578)
@@ -2,7 +2,7 @@
 .TH EDPYKOTA "1" "June 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-edpykota \- manual page for edpykota 1.19alpha20_unofficial
+edpykota \- manual page for edpykota 1.19alpha28_unofficial
 .SH DESCRIPTION
-edpykota v1.19alpha20_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+edpykota v1.19alpha28_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 A Print Quota editor for PyKota.
 .PP
Index: /pykota/trunk/man/pkprinters.1
===================================================================
--- /pykota/trunk/man/pkprinters.1 (revision 1540)
+++ /pykota/trunk/man/pkprinters.1 (revision 1578)
@@ -2,7 +2,7 @@
 .TH PKPRINTERS "1" "June 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-pkprinters \- manual page for pkprinters 1.19alpha20_official
+pkprinters \- manual page for pkprinters 1.19alpha28_unofficial
 .SH DESCRIPTION
-pkprinters v1.19alpha20_official (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+pkprinters v1.19alpha28_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 A Printers Manager for PyKota.
 .PP
Index: /pykota/trunk/man/pykotme.1
===================================================================
--- /pykota/trunk/man/pykotme.1 (revision 1540)
+++ /pykota/trunk/man/pykotme.1 (revision 1578)
@@ -2,7 +2,7 @@
 .TH PYKOTME "1" "June 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-pykotme \- manual page for pykotme 1.19alpha20_unofficial
+pykotme \- manual page for pykotme 1.19alpha28_unofficial
 .SH DESCRIPTION
-pykotme v1.19alpha20_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+pykotme v1.19alpha28_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Gives print quotes to users.
Index: /pykota/trunk/man/pkhint.1
===================================================================
--- /pykota/trunk/man/pkhint.1 (revision 1540)
+++ /pykota/trunk/man/pkhint.1 (revision 1578)
@@ -2,7 +2,7 @@
 .TH PKHINT "1" "June 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-pkhint \- manual page for pkhint 1.19alpha20_unofficial
+pkhint \- manual page for pkhint 1.19alpha28_unofficial
 .SH DESCRIPTION
-pkhint v1.19alpha20_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+pkhint v1.19alpha28_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 A tool to give hints on what accounting method is best for each printer.
 .PP
Index: /pykota/trunk/man/repykota.1
===================================================================
--- /pykota/trunk/man/repykota.1 (revision 1540)
+++ /pykota/trunk/man/repykota.1 (revision 1578)
@@ -2,7 +2,7 @@
 .TH REPYKOTA "1" "June 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-repykota \- manual page for repykota 1.19alpha20_unofficial
+repykota \- manual page for repykota 1.19alpha28_unofficial
 .SH DESCRIPTION
-repykota v1.19alpha20_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+repykota v1.19alpha28_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Generates print quota reports.
Index: /pykota/trunk/man/warnpykota.1
===================================================================
--- /pykota/trunk/man/warnpykota.1 (revision 1540)
+++ /pykota/trunk/man/warnpykota.1 (revision 1578)
@@ -2,7 +2,7 @@
 .TH WARNPYKOTA "1" "June 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-warnpykota \- manual page for warnpykota 1.19alpha20_unofficial
+warnpykota \- manual page for warnpykota 1.19alpha28_unofficial
 .SH DESCRIPTION
-warnpykota v1.19alpha20_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+warnpykota v1.19alpha28_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Sends mail to users over print quota.
Index: /pykota/trunk/NEWS
===================================================================
--- /pykota/trunk/NEWS (revision 1575)
+++ /pykota/trunk/NEWS (revision 1578)
@@ -24,4 +24,6 @@
     - 1.19alpha28 :
     
+        - Improved pkhint
+        
         - First working PCL6 (aka PCLXL) parser !
           Doesn't handle copies yet.